


function [A_combined A_allslices]=compute_system_matrix(adj,system,spokes,freq_offset,SP_mean)
% function [A_combined A_allslices]=compute_system_matrix(adj,system,spokes,freq_offset,SP_mean)

gamma=42.576*1e6;

A_allslices=cell(adj.nz,1);
for sl=1:adj.nz
    
    A_allslices{sl}=zeros(adj.slices{sl}.nnonzeropixels,spokes.nspokes*system.ncoils);    
    for chn=1:system.ncoils    
    
        for sp=1:spokes.nspokes            
            deltab0=( spokes.ntimes-spokes.sinc_time_and_spoke_to_time(:,sp) )*system.deltat*( adj.slices{sl}.b0map(adj.slices{sl}.ind')+freq_offset );            
            ktrans=spokes.k( spokes.sinc_time_and_spoke_to_time(1,sp),1:2 );            
            
            A_allslices{sl}( :,chn+(sp-1)*system.ncoils )=1j*2*pi*gamma*adj.slices{sl}.b1maps(chn,adj.slices{sl}.ind)*system.deltat ...
                .* exp( 1j*2*pi*(ktrans*adj.slices{sl}.nonzeropixels(:,4:5)') ) ...
                .* ( spokes.subpulse.' * exp( -1j*2*pi*deltab0 ) ) ...  % the un-shofted subpulse has to be considered se the magnetization is evaluated at z=z_slice, not at 0
                * SP_mean(sl);                                         % therefore there is an extra exp(j*w_slice*t) term in the spokes exponential that cancels the phase ramp
        end
    end
end

A_combined=sparse( blkdiag(A_allslices{:}) );












