

function h=dualhess(xrf,lambda,A,adj,spokes,sar,solver)
% function h=dualhess(xrf,lambda,A,adj,spokes,sar,solver)

system.ncoils=size(adj.b1maps,1);
ncunk=adj.nz * spokes.nspokes * system.ncoils;
ncunk_ps=spokes.nspokes * system.ncoils;
% nconst=sar.nvop+1;

% Hessian of the main function
ch=2.0*A'*A;
h_OBJ=[real(ch) -imag(ch);imag(ch) real(ch)];

if solver==1  % Matlab solver
    LagMult=lambda.ineqnonlin;
else
    LagMult=lambda;
end

% % Hessian of the constraints (SAR)
% subh=zeros(system.ncoils,system.ncoils);
% for n=1:nconst
%     subh=subh + 2.0*LagMult(n)*reshape(sar.sarmats(n,:,:),system.ncoils,system.ncoils);
% end
% ch=zeros(ncunk,ncunk);
% for sp=1:spokes.nspokes
%     for sl1=1:adj.nz
%         ind1_s=(sl1-1)*spokes.nspokes*system.ncoils + (sp-1)*system.ncoils + 1;
%         ind1_e=(sl1-1)*spokes.nspokes*system.ncoils + sp*system.ncoils;
%         for sl2=1:adj.nz
%             ind2_s=(sl2-1)*spokes.nspokes*system.ncoils + (sp-1)*system.ncoils + 1;
%             ind2_e=(sl2-1)*spokes.nspokes*system.ncoils + sp*system.ncoils;
%             ch( ind1_s:ind1_e,ind2_s:ind2_e )=subh*(spokes.sinc(:,sl2,sp)'*spokes.sinc(:,sl1,sp));
%         end
%     end
% end
% h_CON_SAR=[ real(ch) -imag(ch)';imag(ch)' real(ch) ];


% % Hessian of the constraints (max. power) -- DOESN'T WORK, SEE FN().
% % CORRECT VERSION OF THE CONSTRAINT IS BELOW
% % tmp=LagMult(nconst+1:nconst+ncunk_ps);
% tmp=LagMult(1:ncunk_ps);
% tmp2=repmat( diag(tmp),[adj.nz adj.nz] );
% h_CON_MAX=2.0*[ tmp2 zeros(ncunk);
%                 zeros(ncunk) tmp2 ]; % real and imag
            
          
% Hessian of the constraints (max. power) -- HESSIAN OF MAX RF CONSTRAINTS
% AT ALL TIME POINT (CORRECT VERSION)
ch=zeros(ncunk,ncunk);
for sp=1:spokes.nspokes    
    % lam=LagMult( (sar.nvop+1)+(sp-1)*system.ncoils*spokes.ntimesperspoke+1:(sar.nvop+1)+sp*system.ncoils*spokes.ntimesperspoke  );
    lam=LagMult( (sp-1) * system.ncoils * spokes.ntimesperspoke+1 : sp * system.ncoils * spokes.ntimesperspoke  );    
    for sl1=1:adj.nz
        ind1_s=(sl1-1) * spokes.nspokes * system.ncoils + (sp-1) * system.ncoils + 1;
        ind1_e=(sl1-1) * spokes.nspokes * system.ncoils + sp * system.ncoils;        
        for sl2=1:adj.nz            
            ind2_s=(sl2-1) * spokes.nspokes * system.ncoils + (sp-1) * system.ncoils + 1;
            ind2_e=(sl2-1) * spokes.nspokes * system.ncoils + sp * system.ncoils;            
            tmp=[];
            for chn=1:system.ncoils
                tmp=[tmp;spokes.sinc(:,sl2)'*( spokes.sinc(:,sl1).*lam( (chn-1) * spokes.ntimesperspoke+1 : chn * spokes.ntimesperspoke ) )];
            end
            ch( ind1_s:ind1_e,ind2_s:ind2_e )=2*diag(tmp);
        end
    end
end
h_CON_MAX=[ real(ch) -imag(ch)';imag(ch)' real(ch) ];

% h=h_OBJ + h_CON_MAX + h_CON_SAR;
h=h_OBJ + h_CON_MAX;



