


function h=dualhess_MLS(xrf,lambda,A,adj,spokes,sar,solver)
% function h=dualhess_MLS(xrf,lambda,A,adj,spokes,sar,solver)

nchannels=size(adj.b1maps,1);
ncunk=adj.nz * spokes.nspokes * nchannels;
ncunk_ps=spokes.nspokes * nchannels;

% Hessian of the main function
rf=xrf(1:ncunk) + 1j*xrf(ncunk+1:end);
MT=A*rf;

y=abs(MT) - abs(adj.mtttot);
z=sqrt( abs(adj.mtttot)./abs(MT) ) .* exp(1j*angle(MT));
w=y./abs(MT);

z( abs(MT)==0 )=0;
w( abs(MT)==0 )=0;

% X=A'*diag(z);
X=A'.*repmat(z.',[ncunk 1]);  % faster

% Y=A'*diag(w)*A;
Y=( A'.*repmat(w.',[ncunk 1]) )*A;  % faster

h11=2*real(X)*real(X)' + 2*real(Y);
h12=2*real(X)*imag(X)' - 2*imag(Y);
h21=h12';
h22=2*imag(X)*imag(X)' + 2*real(Y);

h_OBJ=[ h11 h12;h21 h22 ];

if solver==1  % Matlab solver
    LagMult=lambda.ineqnonlin;
else
    LagMult=lambda;
end

% % Hessian of the constraints (SAR)
% subh=zeros(nchannels,nchannels);
% for n=1:nconst
%     subh=subh + 2.0*LagMult(n)*reshape(sar.sarmats(n,:,:),nchannels,nchannels);
% end
% ch=zeros(ncunk,ncunk);
% for sp=1:spokes.nspokes
%     for sl1=1:adj.nz
%         ind1_s=(sl1-1)*spokes.nspokes*nchannels + (sp-1)*nchannels + 1;
%         ind1_e=(sl1-1)*spokes.nspokes*nchannels + sp*nchannels;
%         for sl2=1:adj.nz
%             ind2_s=(sl2-1)*spokes.nspokes*nchannels + (sp-1)*nchannels + 1;
%             ind2_e=(sl2-1)*spokes.nspokes*nchannels + sp*nchannels;
%             ch( ind1_s:ind1_e,ind2_s:ind2_e )=subh*(spokes.sinc(:,sl2,sp)'*spokes.sinc(:,sl1,sp));
%         end
%     end
% end
% h_CON_SAR=[ real(ch) -imag(ch)';imag(ch)' real(ch) ];



% % Hessian of the constraints (max. power) -- DOESN'T WORK, SEE FN().
% % CORRECT VERSION OF THE CONSTRAINT IS BELOW
% % tmp=LagMult(nconst+1:nconst+ncunk_ps);
% tmp=LagMult(1:ncunk_ps);
% tmp2=repmat( diag(tmp),[adj.nz adj.nz] );
% h_CON_MAX=2.0*[ tmp2 zeros(ncunk);
%                 zeros(ncunk) tmp2 ]; % real and imag
            
          
% Hessian of the constraints (max. power) -- HESSIAN OF MAX RF CONSTRAINTS
% AT ALL TIME POINT (CORRECT VERSION)
ch=zeros(ncunk,ncunk);
for sp=1:spokes.nspokes    
    % lam=LagMult( (sar.nvop+1)+(sp-1)*nchannels*spokes.ntimesperspoke+1:(sar.nvop+1)+sp*nchannels*spokes.ntimesperspoke  );
    lam=LagMult( (sp-1) * nchannels * spokes.ntimesperspoke+1 : sp * nchannels * spokes.ntimesperspoke  );    
    for sl1=1:adj.nz
        ind1_s=(sl1-1) * spokes.nspokes * nchannels + (sp-1) * nchannels + 1;
        ind1_e=(sl1-1) * spokes.nspokes * nchannels + sp * nchannels;        
        for sl2=1:adj.nz            
            ind2_s=(sl2-1) * spokes.nspokes * nchannels + (sp-1) * nchannels + 1;
            ind2_e=(sl2-1) * spokes.nspokes * nchannels + sp * nchannels;            
            tmp=[];
            for chn=1:nchannels
                tmp=[tmp;spokes.sinc(:,sl2)'*( spokes.sinc(:,sl1).*lam( (chn-1) * spokes.ntimesperspoke+1 : chn * spokes.ntimesperspoke ) )];
            end
            ch( ind1_s:ind1_e,ind2_s:ind2_e )=2*diag(tmp);
        end
    end
end
h_CON_MAX=[ real(ch) -imag(ch)';imag(ch)' real(ch) ];

% h=h_OBJ + h_CON_MAX + h_CON_SAR;
h=h_OBJ + h_CON_MAX;




