


function [c ceq dc dceq]=fn(xrf,adj,spokes,sar,system)
% function [c ceq dc dceq]=fn(xrf,adj,spokes,sar,system)

% no equality constraints
ceq=[];
dceq=[];

% % inequality constraints (SAR)
ncunk=adj.nz * system.ncoils * spokes.nspokes;
rf=reshape( xrf(1:ncunk) + 1j*xrf(ncunk+1:2*ncunk),1,ncunk );  % row vector
rf2=reshape(rf.',system.ncoils*spokes.nspokes,adj.nz).';  % nslices*(nspokes*system.ncoils) matrix with the RF pulses for all pulses

c=[];
dc=[];

% c=zeros(sar.nvop+1,1);
% if nargout>1
%     dc=zeros(2*ncunk,sar.nvop+1);
% end
% 
% for i=1:sar.nvop+1
%     
%     for sp=1:spokes.nspokes
%         inds=(sp-1)*system.ncoils+1:sp*system.ncoils;
%         tmp=[];
%         for sl=1:adj.nz
%             tmp=[tmp reshape(sar.sarmats(i,:,:),system.ncoils,system.ncoils)*rf2(sl,inds)'];
%         end
%         for sl=1:adj.nz
%             % SAR
%             c(i)=c(i) + real( rf2(sl,inds)*tmp(:,sl)*spokes.sumsincsq );  % SAR of individual pulses
%             for sl2=sl+1:adj.nz
%                 c(i)=c(i) + 2.0*real( rf2(sl,inds)*tmp(:,sl2)*( spokes.sinc(:,sl2,sp)'*spokes.sinc(:,sl,sp) ) );  % SAR cross terms
%             end
%             if nargout>1
%                 % SAR derivative if needed
%                 tmp2=zeros(system.ncoils,1);
%                 for sl2=1:adj.nz
%                     tmp2=tmp2 + tmp(:,sl2)*( spokes.sinc(:,sl2,sp)'*spokes.sinc(:,sl,sp) );
%                 end
%                 inds2=(sl-1)*spokes.nspokes*system.ncoils + (sp-1)*system.ncoils + 1: (sl-1)*spokes.nspokes*system.ncoils + sp*system.ncoils;
%                 dc( inds2,i )=2*real(tmp2);
%                 dc( ncunk+inds2,i )=-2*imag(tmp2);
%             end
%         end
%     end
%     if i==sar.nvop+1
%         c(i)=c(i) - sar.gsarmax;
%     else
%         c(i)=c(i) - sar.lsarmax;
%     end
% end


% % inequality constraints (max. power) -- DOESN'T WORK!! IT IS NOT
% % SUFFICIENT TO CONSTRAIN THE SUM RF PULSE AT A SINGLE POINT... ALL RF
% % POINTS HAVE TO BE CONSTRAINED (CORRECT CODE BELOW)
% xsqmax=system.umax^2;
% rf_sum=sum( rf2,1 );
% c=[ c;abs(rf_sum.').^2-xsqmax ];
% 
% if nargout>2
%     dc_MAX_CON=repmat( diag(rf_sum),[adj.nz 1] );
%     dc=[ dc 2*[ real(dc_MAX_CON);imag(dc_MAX_CON) ] ];
% end


% inequality constraints (max. power) -- CONSTRAIN MAX RF AT ALL RF SAMPLES
xsqmax=system.umax^2;
rfsum=zeros(spokes.nspokes * system.ncoils * spokes.ntimesperspoke,1);  % explicit expansion of the RF waveforms
tmp=[];
for sp=1:spokes.nspokes
    for chn=1:system.ncoils
        indstart=(sp-1) * spokes.ntimesperspoke * system.ncoils + (chn-1) * spokes.ntimesperspoke;
        rfsum( indstart+1:indstart+spokes.ntimesperspoke,1 )=spokes.sinc(:,:)*rf2( :,(sp-1)*system.ncoils+chn );
        if nargout>1
            tmp=blkdiag( tmp,rfsum(indstart+1:indstart+spokes.ntimesperspoke,1).' );
        end
    end
end
c=[c;abs(rfsum).^2-xsqmax];

if nargout>1
    dctmp=zeros( 2*ncunk,spokes.nspokes * system.ncoils * spokes.ntimesperspoke );
    for sl=1:adj.nz
        tmp2=[];
        for sp=1:spokes.nspokes
            tmp2=blkdiag( tmp2,kron(eye(system.ncoils),spokes.sinc(:,sl)') );
        end
        tmp2=tmp2.*tmp;
        dctmp( (sl-1)*spokes.nspokes*system.ncoils+1:sl*spokes.nspokes*system.ncoils,: )=2*real(tmp2);
        dctmp( ncunk+(sl-1)*spokes.nspokes*system.ncoils+1:ncunk+sl*spokes.nspokes*system.ncoils,: )=2*imag(tmp2);
    end
    dc=[dc dctmp];
end













