


function spokes=opt_gradients(spokes,system,opt,sar,adj,do_mls,SPs_mean)
% function spokes=opt_gradients(spokes,system,opt,sar,adj,do_mls,SPs_mean)

global A;
global spcoords;

spcoords=inf( 2*spokes.nspokes,1 );  % initial the sp coord vector with garbage to force computation of the 
ncunk=system.ncoils*spokes.nspokes*adj.nz;

% START FROM LS/MLS PULSE
spokes=prepare_pulse(spokes,adj,system,opt.display);
A=compute_system_matrix(adj,system,spokes,0,SPs_mean);

% initial RF estimate (LS)
options=optimset('Display','iter-detailed','MaxFunEvals',10^5,'TolFun',1e-6,'TolCon',1e-6,'MaxIter',5000,...
    'Algorithm','interior-point','GradObj','on','GradConstr','on');
options.Hessian='user-supplied';
options.HessFcn=@(xrf,lambda)dualhess(xrf,lambda,A,adj,spokes,sar,1);
xrf0=zeros(2*ncunk,1);
[xrf fval exitflag output lambda]=fmincon(@(xrf)f0(xrf,A,adj),xrf0,[],[],[],[],[],[],@(xrf)fn(xrf,adj,spokes,sar,system),options);    

% initial RF estimate (MLS refinement)
if do_mls==1
    options.Hessian='user-supplied';
    options.HessFcn=@(xrf,lambda)dualhess_MLS(xrf,lambda,A,adj,spokes,sar,1);    
    % options.Hessian='';
    [xrf fval exitflag output lambda]=fmincon(@(xrf)f0_MLS(xrf,A,adj),xrf,[],[],[],[],[],[],@(xrf)fn(xrf,adj,spokes,sar,system),options);
end

% START FROM 0 PULSE
% xrf=zeros( 2*ncunk,1 );

xsp0=zeros(2*spokes.nspokes,1);
for i=1:spokes.nspokes
    xsp0( (i-1)*2+1,1 )=spokes.spcoords(i,1);
    xsp0( (i-1)*2+2,1 )=spokes.spcoords(i,2);
end

% fac=max(abs(xrf));
fac=100;  % this makes the spoke locations on the same order than the RF values
x0=[xsp0*fac;xrf];

% jointly optimize RF and spoke positions
% x0=rand(size(x0));
% test_gradient( @(x)f0_gr(x,adj,opt,spokes,system,do_mls,fac,SPs_mean),x0 )
% test_gradient( @(x)fn_gr(x,adj,spokes,sar,system),x0 )
% lambda=ones(100,1);
% test_hessian( @(x)f0_gr(x,adj,opt,spokes,system,do_mls,fac,SPs_mean),@(x)dualhess_gr(x,lambda,fac,adj,spokes,sar,system,opt,SPs_mean,do_mls,2),x0 );
% test_hessian( @(x)fn_gr(x,adj,spokes,sar,system),@(x)dualhess_gr(x,lambda,fac,adj,spokes,sar,system,opt,SPs_mean,do_mls,2),x0 );
options=optimset('Display','iter-detailed','MaxFunEvals',1e5,'TolFun',1e-3,'TolCon',1e-3,...
    'MaxIter',50,'Algorithm','interior-point','GradObj','on','GradConstr','on');
options.Hessian='user-supplied';
options.HessFcn=@(x,lambda)dualhess_gr(x,lambda,fac,adj,spokes,sar,system,opt,SPs_mean,do_mls,1);
% options.Hessian='';
[x fval exitflag output lambda]=fmincon( @(x)f0_gr(x,adj,opt,spokes,system,do_mls,fac,SPs_mean),x0,[],[],[],[],[],[],@(x)fn_gr(x,adj,spokes,sar,system),options );

for i=1:spokes.nspokes
    spokes.spcoords(i,1)=x( (i-1)*2+1,1 )/fac;
    spokes.spcoords(i,2)=x( (i-1)*2+2,1 )/fac;
end










