

function adj2=prepare_optimization(opt,spokes,system,adj)
% function adj2=prepare_optimization(opt,spokes,system,adj)

adj2=adj;

adj2.slices=cell(adj2.nz,1);
nfigs=ceil(sqrt(system.ncoils));

adj2.mtttot=[];
adj2.nnonzeropixels=0;

to_disp_roi=[];
to_disp_b1=[];
to_disp_b0=[];
adj2.nonzeropixels=[];
for sl=1:adj2.nz
    
    % non-zero pixels    
    if strcmpi(opt.display,'on')
        to_disp_roi=[ to_disp_roi adj2.roi(:,:,sl) ];        
    end
    
    roi_sl=adj2.roi(:,:,sl);
    adj2.slices{sl}.ind=find(roi_sl>0);
    adj2.slices{sl}.nnonzeropixels=size(adj2.slices{sl}.ind,1);
    [indx indy]=ind2sub( [adj2.nx adj2.ny],adj2.slices{sl}.ind );
    [tmpx tmpy]=ndgrid(adj.xs,adj.ys);
    adj2.slices{sl}.nonzeropixels=[ indx indy ones(adj2.slices{sl}.nnonzeropixels,1) tmpx(adj2.slices{sl}.ind) tmpy(adj2.slices{sl}.ind) ones(adj2.slices{sl}.nnonzeropixels,1)*adj2.zs(sl) ];
    adj2.nnonzeropixels = adj2.nnonzeropixels + adj2.slices{sl}.nnonzeropixels;
    
    adj2.nonzeropixels=[ adj2.nonzeropixels;adj2.slices{sl}.nonzeropixels ];
    
    % target magnetization
    adj2.slices{sl}.mttimg=adj2.roi(:,:,sl) * sin( opt.tfa/180.0*pi );
    adj2.slices{sl}.mtt=adj2.slices{sl}.mttimg( adj2.slices{sl}.ind );    
    adj2.mtttot=[ adj2.mtttot;adj2.slices{sl}.mtt ];

    % display B1 maps
    if strcmpi(opt.display,'on')        
        to_disp_b1=[ to_disp_b1 conv_3Dstack_2_2Dimg( permute(adj2.b1maps(:,:,:,sl),[2 3 1]),system.ncoils,1 ) ];        
    end
    
    % display B0 map
    if strcmpi(opt.display,'on')
        to_disp_b0=[ to_disp_b0 adj2.b0map(:,:,sl) ];
    end
    
    adj2.slices{sl}.b0map=adj2.roi(:,:,sl);
    adj2.slices{sl}.b0_=adj2.slices{sl}.b0map( adj2.slices{sl}.ind );
    adj2.slices{sl}.b1maps=adj2.b1maps(:,:,:,sl);

end

if strcmpi(opt.display,'on')
    
    figure;
    imagesc(to_disp_roi); axis image off; title('Optimization ROIs, all slices');
    
    figure;         
    imagesc(abs(to_disp_b1)); axis image off; colormap(hot); colorbar;
    title('B1 maps, all slices [T/V]');
    
    figure;         
    imagesc(angle(to_disp_b1)); axis image off; colormap(hot); colorbar; caxis([-pi pi]);
    title('B1 maps, all slices [rad.]');
    
    figure;
    imagesc(to_disp_b0); axis image off; colorbar; title('B0 maps, all slices [Hz]');
end








