



function test_gradient2(fhandle,x)
% function test_gradient2(fhandle,x)

[f df]=fhandle(x);

eps=1e-6;
nunk=size(df,1);
nconst=size(df,2);

diff_num=zeros(nunk,nconst);
diff_an=zeros(nunk,nconst);

maxdiff=-1;
meandiff=0;
for i=1:nunk
    fprintf('\tComputing row #%d out of %d ...\n',i,nunk);
    x2=x;
    x2(i)=x2(i)+eps;
    [f2 df2]=fhandle(x2);
    for j=1:nconst
        diff_num(i,j)=(f2(j)-f(j))/eps;
        diff_an(i,j)=df(i,j);
        maxdiff=max(maxdiff,abs((f2(j)-f(j))/eps - df(i,j)));
        meandiff=meandiff + abs((f2(j)-f(j))/eps - df(i,j));
    end
end

f=figure; imagesc(diff_an); colormap(hot); axis off; colorbar; title('Analytical differentiation'); % caxis([min(min(diff_an)) max(max(diff_an))]); 
f2=figure; imagesc(diff_num); colormap(hot); axis off; colorbar; title('Numerical differentiation'); % caxis([min(min(diff_an)) max(max(diff_an))]); 
f3=figure; imagesc(diff_an-diff_num); colormap(hot); axis off; colorbar; title('Analytical - numerical'); % caxis([min(min(diff_an)) max(max(diff_an))]); 

fprintf('\n\n----------------------------------\n');
fprintf('Maximum absolute difference between numerical and analytical derivatives is %e.\n',maxdiff);
fprintf('Mean absolute difference between numerical and analytical derivatives is %e.\n',meandiff/(nunk*nconst));
fprintf('----------------------------------\n\n');




