

function mtimg=write_and_display_magnetization(rf,adj,system,spokes,SPs_mean,opt)
% function mtimg=write_and_display_magnetization(rf,adj,system,spokes,SPs_mean,opt)

mt=full(opt.A)*rf;

nend=0;
to_disp_mag=[];
mtimg=cell(adj.nz,1);
for sl=1:adj.nz
    nstart=nend+1;
    nend=nend + adj.slices{sl}.nnonzeropixels;
   
    mtimg{sl}=zeros(adj.nx,adj.ny);
    mtimg{sl}(adj.slices{sl}.ind)=mt(nstart:nend,1);    

    if strcmpi(opt.display,'on')
        to_disp_mag=[ to_disp_mag mtimg{sl} ];
    end
end

if strcmpi(opt.display,'on')
    figure;
    subplot(2,1,1); imagesc( real(asin(abs(to_disp_mag))/pi*180) ); colormap(hot); caxis([0 opt.tfa*1.5]); colorbar; axis image off; 
    title('Flip angle map, STA, all slices [deg.]');
    
    subplot(2,1,2); imagesc( angle(to_disp_mag) ); colormap(hot); caxis([-pi pi]); colorbar; axis image off; 
    title('Flip angle map, STA, all slices [rad.]');
end




